#include <windows.h>
//#include <iostream.h>

const int IMAGE_HEADER_SIZE = 256;

const int MAX_X_RANGE = 612696067;
const int MAX_Y_RANGE = 2349858820;
const int MAX_Z_RANGE = 3176136704;

const DWORD IMG_VERSION = 0x40466666;

const int DEFAULT_HEAD_ID = 4;
const int DEFAULT_ZOOM_FACTOR = 1;
const int DEFAULT_Z_GAIN = 1;
const int DEFAULT_LINEARITY = 32076;

#pragma pack( push, 1 )
typedef
struct IMGHeadTAG
{
 DWORD version;
 WORD  headerSize;
 WORD  NumberOfSamples;
 WORD  NumberOfScanlines;
 DWORD MaxXRange;
 DWORD MaxYRange;
 DWORD MaxZRange;
 DWORD XRange;
 DWORD YRange;
 DWORD ZRange;
 WORD  DataType;
 WORD  HeadID;
 WORD  ZoomFactor;
 WORD  ZGain;
 WORD  PreSampleDelay;
 WORD  PreRetraceDelay;
 WORD  PreScanLineDelay;
 WORD  PreScanRetraceDelay;
 WORD  PreFrameDelay;
 WORD  NumberOfSubSteps;
 WORD  Linearity;
 float BiasVoltage;
 float TunnelingCurrent;
 float ReferenceForce;
 char  ImageTitle[31];
 char  ImageComments[161];
} IMGHead;
#pragma pack( pop, 1 )


typedef struct {
	DWORD MaxXRange;
	DWORD MaxYRange;
	DWORD MaxZRange;
	WORD  Z_gain;      // Z_gain = 0 --> X1, 1 --> X5, 2 --> X25, 3 --> X125
	WORD  Zoom_level;
	BYTE  Chanel;
	} TD2;


void SaveIMG(char* fileName, WORD* data, int width, int height, TD2* pInfo)
{
 IMGHead header;
 HANDLE fileHandle;
 register i,x,y;
 WORD temp;
 BYTE FunctionResult;
 DWORD Error;

 header.version = IMG_VERSION;
 header.headerSize = IMAGE_HEADER_SIZE;
 header.NumberOfSamples = width;
 header.NumberOfScanlines = height;
 header.MaxXRange = pInfo->MaxXRange;
 header.MaxYRange = pInfo->MaxYRange;
 header.MaxZRange = pInfo->MaxZRange;
 header.XRange = pInfo->MaxXRange;			// MAX X IN ANGSTREMS
 header.YRange = pInfo->MaxYRange;			// MAX Y IN ANGSTREMS
 //header.ZRange = pInfo->MaxZRange/2;			// MAX Z = (1(units depends on DataType)/ZGain)
 // CALCULATING MAX Z RANGE
 switch(pInfo->Z_gain)
 {
  case 1: header.ZGain=5; break;
  case 2: header.ZGain=25; break;
  case 3: header.ZGain=125; break;
  default: header.ZGain=DEFAULT_Z_GAIN;
 };
 // let the temp contains the maximum value from data[] 
 temp = data[0];
 for( y=0;y<height;y++)
 for( x=0;x<width;x++)
	if(temp < data[x*height + y]) temp = data[x*height + y];
 header.ZRange = (DWORD)((double)(header.MaxZRange*temp)/(double)0xfff);

 header.DataType = pInfo->Chanel&0x03; 
					  // = GetDataType();
					  // determines units in Z direction
					  // 0 - picoamps
					  // 1 - angstroms
					  // 2 - piconewtons					  
 header.HeadID = DEFAULT_HEAD_ID; // = GetHeadID();
 header.ZoomFactor = pInfo->Zoom_level; // = GetZoomFactor();

 header.PreSampleDelay = header.PreRetraceDelay = header.PreScanLineDelay = 
 header.PreScanRetraceDelay = header.PreFrameDelay = 0;
 header.NumberOfSubSteps = 1;
 header.Linearity = DEFAULT_LINEARITY; // = GetLinearity();
 header.BiasVoltage = header.TunnelingCurrent = header.ReferenceForce = 0;

 for( i=0;i<31;i++) header.ImageTitle[i]=0;
 for( i=0;i<161;i++) header.ImageComments[i]=0;

    if((fileHandle = CreateFile((LPCSTR)fileName,
		                       GENERIC_WRITE,
							   FILE_SHARE_WRITE,
							   NULL,
							   OPEN_ALWAYS, //OPEN_ALWAYS,
							   FILE_ATTRIBUTE_NORMAL,
							   NULL))!=
	   INVALID_HANDLE_VALUE)
	{
		//cout << "Create img file -OK !"<< endl;
		DWORD writtenBytes = 0; //sizeof(IMGHead);
		SetFilePointer(fileHandle,0,&writtenBytes,FILE_BEGIN);
		
		FunctionResult = WriteFile(fileHandle, (LPCVOID)&header, sizeof(IMGHead), &writtenBytes, NULL);
		if(FunctionResult == 0)
		    Error =  GetLastError();  //112- Fisk Full
		//else
			//cout << "Save header img file -OK !"<< endl;

		/*for( y=0; y<height; y++ )
        for( x=0; x<width;  x++ )
		{
	     temp = data[x*height + y];
		 WriteFile(fileHandle, (LPCVOID)&temp, sizeof(WORD), &writtenBytes, NULL);
		}*/
		FunctionResult = WriteFile(fileHandle, (LPCVOID)data, sizeof(WORD)*width*height, &writtenBytes, NULL);
        if(FunctionResult == 0)
		    Error =  GetLastError(); //112- Fisk Full
		//else
		//cout << "Save data img file -OK !"<< endl;

		FlushFileBuffers(fileHandle);
		CloseHandle(fileHandle);
	}
	else
		MessageBox(0,"Can't create file.", "Error", MB_OK|MB_ICONSTOP);

}